// ----------------------------------------------------------------------------
//
//  Copyright (C) 2017-2018 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __ABPROCESS_H
#define __ABPROCESS_H


#include "abconfig.h"
#include "convol88.h"
#include "svhipf.h"
#include "svparf.h"



class ABprocess
{
public:

    ABprocess (void);
    ~ABprocess (void);

    void init (int sampfreq, int fragsize);
    void reset (void);
    int  load_config (ABconfig *C);
    void set_hipfil (float f) { _hipconf.setfreq (f / _sampfreq); }
    void set_invmic (bool v) { _invmic = v; }
    void set_shnorm (int k)  { _shnorm = k; } 
    void process (float *inp [8], float *out [9]);

private:

    int init_convproc (const char *convfile);

    int             _sampfreq;
    int             _fragsize;
    Svhip_conf      _hipconf;
    Svhip_filt      _hipfilt [8];
    Svpar_conf      _lfeqconf;
    Svpar_filt      _lfeqfilt [8];
    Convol88       *_convproc;
    bool            _invmic;
    int             _shnorm;
};


#endif
